using Recrovit.RecroGridFramework;
using Recrovit.RecroGridFramework.Data;
using Recrovit.RecroGridFramework.Security;
using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Web;

namespace $rootnamespace$.Areas.RGF
{
    public class AdminModel
    {
        public AdminModel() : this(null) { }
        public AdminModel(bool? initDatabase)
        {
            this.InitDatabase = initDatabase ?? !RGDataContext.IsDatabaseInitialized;
        }

        public RecroGrid Grid { get; set; } = null;
        public string EntityType { get; set; }
        public string RecroGridType { get; set; }
        public string Theme { get; set; }
        public bool InitDatabase { get; }
        public IEnumerable<string> Entities
        {
            get
            {
                using (var context = new RGDataContext())
                {
                    var list = context.EntityNames.ToList();
                    list.Insert(0, "");
                    return list;
                }
            }
        }
        public IEnumerable<string> RecroGridTypeList { get { return RGDataContext.RecroGridTypeList; } }
        public IEnumerable<string> Themes
        {
            get
            {
                DirectoryInfo dir = new DirectoryInfo(Path.Combine(RecroGridConfig.WebRootPath, "jQueryUIThemes"));
                var list = dir.GetDirectories().Select(d => d.Name).ToList();
                return list;
            }
        }
        public IEnumerable<string> Languages
        {
            get
            {
                return RecroDict.GetAllItems("RecroDict.Language").Select(l => l.Key).ToList();
            }
        }

        public RecroSecGUI RecroSecModel { get; set; } = null;
    }
}
