namespace $rootnamespace$.DBModel
{
    using Microsoft.EntityFrameworkCore;
    using System;
    using System.ComponentModel.DataAnnotations.Schema;
    using System.Linq;

    //Scaffold-DbContext "Server=(localdb)\mssqllocaldb;Database=RGFDemoCore;Trusted_Connection=True;" Microsoft.EntityFrameworkCore.SqlServer -o DBModel
    //Scaffold-DbContext "Host=postgresql.lan;Database=RGFDemoCore;Username=recrogrid;Password=P@ssw0rd" Npgsql.EntityFrameworkCore.PostgreSQL -o DBModel
    //Add-Migration InitialCreate -Context DatabaseContext -OutputDir DBModel\Migrations

    public partial class DatabaseContext : DbContext
    {
        public DatabaseContext() { }
        public DatabaseContext(DbContextOptions<DatabaseContext> options) : base(options) { }

        //public virtual DbSet<Recrovit.RecroGridFramework.Data.vRecroSec> vRecroSec { get; set; }
        //public virtual DbSet<Recrovit.RecroGridFramework.Data.vRecroSec_FEP> vRecroSec_FEP { get; set; }

        protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
        {
#if PGSQL
            //PostgreSQL 
            optionsBuilder.UseNpgsql(Recrovit.RecroGridFramework.Data.RGDataContext.DefaultConnectionString);
#else
            optionsBuilder.UseSqlServer(Recrovit.RecroGridFramework.Data.RGDataContext.DefaultConnectionString);
#endif
        }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            //base.OnModelCreating(modelBuilder);
#if PGSQL
            //PostgreSQL
            modelBuilder.HasDefaultSchema("public");
            var types = modelBuilder.Model.GetEntityTypes().ToList();
            types.ForEach(e => e.Relational().TableName = e.Relational().TableName.ToLower());
            types.SelectMany(e => e.GetProperties()).ToList().ForEach(p => p.Relational().ColumnName = p.Relational().ColumnName.ToLower());
#endif
            Recrovit.RecroGridFramework.Data.Core.RecroGridDbContext.OnModelCreating(this, modelBuilder);
        }
    }
}
